/**************************************************************
 ____________________________________________________________ 
/____________/       Real Space 3-d engine      \____________\
\____________\__________________________________/____________/

**************************************************************/


//this is for a test
// C Source File
// Created 7/30/2003; 5:03:46 PM

         // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#define SAVE_SCREEN  
#define OPTIMIZE_ROM_CALLS
#include "Declearations.h"
#include "Models.h"


// Draws a line from (x1,y2) to (x2,y2).//not my own code (kinda actualy)
// col = 0 baclk
// col = 1 dark gray
// col = 2 light gray

void DrawLineFast(short x1, short y1, short x2, short y2, int col)
{
	if ((P1_x >= 0 || P1_y >= 0) && (P2_x <= 160 || P2_y <= 100))
	{
		//continue without problems
			//test area for clipping
	}
	else 
	{
		if ((P1_x < 0 || P1_y < 0) && (P2_x > 160 || P2_y > 100));
			//do not draw line
	}
//major porblems with lines, skipping

	//can not work, not seen pixels, etc.. 




  short x = x1, y = y1;
  short dx = abs (x2 - x1), dy = abs (y2 - y1);
  short ystep = (y1 < y2) ? 1 : -1, pystep = 30 * ystep;
  short mov = dx ? 0 : -1;
  unsigned char *ptr;
  short mask = 1 << (~x & 7);

	switch(col)
	{
		 case 0:
		 		DrawLineFast( x1,  y1,  x2,  y2, 1);
		 		DrawLineFast( x1,  y1,  x2,  y2, 2);
		 		return;
		case 1:
		  // ptr = (char*)GrayGetPlane(LIGHT_PLANE) + 30 * y + (x >> 3);
		    ptr = Vscreen_L + 30 * y + (x >> 3);
		   break;
		case 2:
		   //ptr = (char*)GrayGetPlane(DARK_PLANE) + 30 * y + (x >> 3);
		   ptr = Vscreen_D + 30 * y + (x >> 3);
		   break;
		 default:
		 		return;
	}

  if (x1 < x2)
    while (x != x2 || y != y2)
      {
        *ptr |= mask;
        if (mov < 0) y += ystep, ptr += pystep, mov += dx;
        else
          {
            mov -= dy;
            if (++x & 7) mask >>= 1;
            else ptr++, mask = 0x80;
          }
      }
  else
    while (x != x2 || y != y2)
      {
        *ptr |= mask;
        if (mov < 0) y += ystep, ptr += pystep, mov += dx;
        else
          {
            mov -= dy;
            if (x-- & 7) mask <<= 1;
            else ptr--, mask = 1;
          }
      }
}




void ClrGray(void)
{
	char *clr_ptr_L, *clr_ptr_D; //*Vscreen;
	int i;
	clr_ptr_D = Vscreen_L;
	clr_ptr_L = Vscreen_D;
//	Vscreen = malloc(3840);
	for(i=0;i<3840;i++)
		{
			*clr_ptr_D++ = 0;
			*clr_ptr_L++ = 0;
		//	*Vscreen++ = 0;
		}
}


void Draw_obj(OBJ_3D *model)  //Draw_obj(CUBE_LINES, CUBE , CUBE_POINTS, LINES, render_color);
{

//finds free space for virtuel screen
//void *Vscreen = malloc(3840);

//fixes the allocated memory to be a buffer area for drawing.
//PortSet(Vscreen,239,127);

//while(! (_rowread( 0x3e ) & 0x01))	//another key read fucntion, but the one im using is more simple
while(! (_keytest (RR_ESC)))
	{
		Vertex Work_OBJ;		
		
		//angle table manipulation
		sin_x = sin128_table[ ang_x ];//this is to check if the objects things are not required.
		cos_x = cos128_table[ ang_x ];
		sin_y = sin128_table[ ang_y ];
		cos_y = cos128_table[ ang_y ];
		sin_z = sin128_table[ ang_z ];
		cos_z = cos128_table[ ang_z ];
	
		//calculates the angle of the camera	
		Camera.y = ( (dist * sin_x) >> 7 );
		Camera.z = ( (dist * cos_x) >> 7 );
		Camera.z = ( (Camera.z * cos_y) >> 7 );
		Camera.x = ( (dist * cos_x) >> 7 );
	  Camera.x = ( (Camera.x * sin_y) >> 7);
		

		for(p=0; p<model->num_points ;p++) //calculates the num points.
		{
			//stores the values in WORK, to be WORKed on with the program
			Work_OBJ.x = model->vertex[p].x - Camera.x;
			Work_OBJ.y = model->vertex[p].y - Camera.y;
			Work_OBJ.z = model->vertex[p].z - Camera.z;

					//rotation around the y axis.
			intermediate = Work_OBJ.z;
			Work_OBJ.z = (- Work_OBJ.x*sin_y - Work_OBJ.z*cos_y ) >> 7;
			Work_OBJ.x = (- Work_OBJ.x*cos_y + intermediate*sin_y ) >> 7;
		
					//rotation around the x axis.
			intermediate = Work_OBJ.z;
			Work_OBJ.z = ( - Work_OBJ.y*sin_x + Work_OBJ.z*cos_x ) >> 7;
			Work_OBJ.y = ( Work_OBJ.y*cos_x + intermediate*sin_x ) >> 7;
	
					//rotation around the z axis.
			intermediate = Work_OBJ.x;
			Work_OBJ.x = ( Work_OBJ.x*cos_z - Work_OBJ.y*sin_z ) >> 7;
			Work_OBJ.y = ( Work_OBJ.y*cos_z + intermediate*sin_z ) >> 7;
				
							
						
			//more calculations...
			model->sp_cube[p].x = (Work_OBJ.x*Distortion)/Work_OBJ.z + Screen_center.x;
			model->sp_cube[p].y = (Work_OBJ.y*Distortion)/Work_OBJ.z + Screen_center.y;
			
			}
			
			ClrGray();
			//clr buffer here.
			for(l=0; l<model->num_lines; l++)   //12 times for 12 lines
			{
				P1_x = model->sp_cube [ model->lines [l].x ].x ; // First Point x value.
				P1_y = model->sp_cube [ model->lines [l].x ].y ; // First Point y value.
				P2_x = model->sp_cube [ model->lines [l].y ].x ; // Second Point x value.
				P2_y = model->sp_cube [ model->lines [l].y ].y ; // Second Point y value.
		
		//		P1_x = SP_CUBE [ LINES [l][0] ].x ; // First Point x value.
		//		P1_y = SP_CUBE [ LINES [l][0] ].y ; // First Point y value.
		//		P2_x = SP_CUBE [ LINES [l][1] ].x ; // Second Point x value.
		//		P2_y = SP_CUBE [ LINES [l][1] ].y ; // Second Point y value.

			
				if (render_speed==0)
					DrawLine ( P1_x , P1_y , P2_x , P2_y , A_NORMAL );
				else
					DrawLineFast ( P1_x , P1_y , P2_x , P2_y, model->color);
					
			}
			
			
			memcpy(GrayGetPlane(LIGHT_PLANE), Vscreen_L, 3840);
			memcpy(GrayGetPlane(DARK_PLANE), Vscreen_D, 3840);
			/* //this does not work, excits out alot and flashes.
			if (_keytest(RR_UP))
				step_x ++;
				
			if (_keytest(RR_DOWN))
				step_x --;
				
			if (_keytest(RR_LEFT))
				step_y ++;
				
			if (_keytest(RR_RIGHT))
				step_y --;
				
			if (_keytest(RR_F1))
				step_z ++;
				
			if (_keytest(RR_F2))
				step_z --;
								
			if (_keytest(RR_F5))
				step_x = 0;
				step_y = 0;
				step_z = 0;
	
			
		//pauses for key reed, thats very bad
			key = ngetchx();
				if (key == KEY_LEFT)
				  {
				    ang_y --;
				  }
				else if (key == KEY_RIGHT)
				  {
				    ang_y ++;
				  }
				else if (key == KEY_UP)
				  {wwwwww
				    ang_x --;
				  }
				else if (key == KEY_DOWN)
				  {
				    ang_x ++;
				  }
				else if (key == KEY_F1)
				  {
				    ang_z --;
				  }
				else if (key == KEY_F2)
				  {
				    ang_z ++;
				  }
				
			
			if (_rowread( 0x02 ) & 0x01)
				step_x ++;
				
			else if (_rowread( 0x02 ) & 0x04)
				step_x --;
				
			else if (_rowread( 0x02 ) & 0x02)
				step_y ++;
				
			else if (_rowread( 0x02 ) & 0x03)
				step_y --;
				
			else if (_keytest(RR_F1))
				step_z ++;
				
			else if (_keytest(RR_F2))
				step_z --;
								
			else if (_keytest(RR_F5))
				step_x = 0;
				step_y = 0;
				step_z = 0;
				*/
			
		
			ang_x += step_x ;
			ang_y += step_y ;
			ang_z += step_z ;

	}

}


// Main Function
void _main(void)
{
	OBJ_3D cube, triangle;
	
	triangle.num_lines = TRI_LINES;
	triangle.num_points = TRI_POINTS;
	triangle.sp_cube = SP_TRI;
	triangle.vertex = TRI_vert;
	triangle.lines = LINES_TRI;
	triangle.color = render_color_TRI;

	
	cube.num_lines = CUBE_LINES;
	cube.num_points = CUBE_POINTS;
	cube.sp_cube = SP_CUBE;
	cube.vertex = CUBE;
	cube.lines = LINES;
	cube.color = render_color;
	

ClrScr();
GrayOn();

	Vscreen_L = malloc(3840);
	Vscreen_D = malloc(3840);
	if (Vscreen_L == 0 || Vscreen_D == 0)
		{
		printf("cannot find memory\n");
		ngetchx();
		exit(0);
		}

	Draw_obj(&cube);
//	Draw_obj(&triangle);
	
	asm("|this is a test for asm functions");
	free(Vscreen_L);
	free(Vscreen_D);
	GrayOff();
	//memcpy(LCD_MEM,Vscreen,3840);
	//free(Vscreen);
	PortRestore();//fixes any vscreen created probems.
}